using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Specialized;
using System.Text;

public partial class Code128Web : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (First.Value.Equals("true"))
        {
            initForm();
            First.Value = "false";
            barcode.ImageUrl = "BC.AspNetBarcodeGeneratorTrial.Code128.aspx?Data=WWW.BARCODEC.COM&Type=Code128";
        }
        else
        {
            GenerateBarcode();
        }

        Url.Value = barcode.ImageUrl;
        
    }

    private void initForm()
    {
        
        Type.Items.Add(new ListItem("Code128", "0"));
        Type.Items.Add(new ListItem("Code128SetA", "1"));
        Type.Items.Add(new ListItem("Code128SetB", "2"));
        Type.Items.Add(new ListItem("Code128SetC", "3"));
        
        

        Type.Items[0].Selected = true;

        AddCheckSum.Items.Add(new ListItem("Yes", "true"));
        AddCheckSum.Items.Add(new ListItem("No", "false"));


        BearerBars.Items.Add(new ListItem("None", "0"));
        BearerBars.Items.Add(new ListItem("Frame", "1"));
        BearerBars.Items.Add(new ListItem("TopBottom", "2"));

        ShowText.Items.Add(new ListItem("Yes", "true"));
        ShowText.Items.Add(new ListItem("No", "false"));

        TextFontName.Items.Add(new ListItem("Arial", "Arial"));
        TextFontName.Items.Add(new ListItem("Times New Roman", "Times New Roman"));

        TextFontSize.Items.Add(new ListItem("8", "8"));
        TextFontSize.Items.Add(new ListItem("9", "9"));
        TextFontSize.Items.Add(new ListItem("10", "10"));
        TextFontSize.Items.Add(new ListItem("11", "11"));
        TextFontSize.Items.Add(new ListItem("12", "12"));
        TextFontSize.Items.Add(new ListItem("13", "13"));
        TextFontSize.Items.Add(new ListItem("14", "14"));

        TextFontSize.Items[1].Selected = true;

        TextFontStyle.Items.Add(new ListItem("Bold", "Bold"));
        TextFontStyle.Items.Add(new ListItem("Italic", "Italic"));
        TextFontStyle.Items.Add(new ListItem("Underline", "Underline"));

        Rotate.Items.Add(new ListItem("Bottom Facing Down", "0"));
        Rotate.Items.Add(new ListItem("Bottom Facing Left", "1"));
        Rotate.Items.Add(new ListItem("Bottom Facing Up", "2"));
        Rotate.Items.Add(new ListItem("Bottom Facing Right", "3"));

        ImageFormat.Items.Add(new ListItem("JPEG", "jpg"));
        ImageFormat.Items.Add(new ListItem("GIF", "gif"));
        ImageFormat.Items.Add(new ListItem("BMP", "bmp"));
        ImageFormat.Items.Add(new ListItem("TIFF", "tif"));

        UOM.Items.Add(new ListItem("Pixel", "0"));
        UOM.Items.Add(new ListItem("CM", "1"));
        UOM.Items.Add(new ListItem("Inch", "2"));

        CodabarStartChar.Items.Add(new ListItem("A", "A"));
        CodabarStartChar.Items.Add(new ListItem("B", "B"));
        CodabarStartChar.Items.Add(new ListItem("C", "C"));
        CodabarStartChar.Items.Add(new ListItem("D", "D"));

        CodabarStopChar.Items.Add(new ListItem("A", "A"));
        CodabarStopChar.Items.Add(new ListItem("B", "B"));
        CodabarStopChar.Items.Add(new ListItem("C", "C"));
        CodabarStopChar.Items.Add(new ListItem("D", "D"));

        UPCENumber.Items.Add(new ListItem("0", "0"));
        UPCENumber.Items.Add(new ListItem("1", "1"));
    }

    private void GenerateBarcode()
    {
        NameValueCollection values = createHttpQueryString();

        StringBuilder builde = new StringBuilder();
        for (int i = 0; i < values.Count; i++)
        {
            if (i != 0)
            {
                builde.Append("&");
            }
            builde.Append(values.GetKey(i));
            builde.Append("=");
            builde.Append(HttpUtility.UrlEncode(values.Get(i)));
        }

        barcode.ImageUrl = "BC.AspNetBarcodeGeneratorTrial.Code128.aspx?" + builde.ToString() ;
    }

    private NameValueCollection createHttpQueryString()
    {
        NameValueCollection values = new NameValueCollection();
        values.Add("Type", Type.SelectedValue);
        values.Add("Data", BCData.Text);
        values.Add("SData", BCSData.Text);
        values.Add("BarWidth", BCBarWidth.Text);
        values.Add("BarHeight", BCBarHeight.Text);
        values.Add("Resolution", BCResolution.Text);
        values.Add("BearerBars", BearerBars.Text);
        values.Add("UOM", UOM.SelectedValue);
        values.Add("LeftMargin", BCLeftMargin.Text);
        values.Add("TopMargin", BCTopMargin.Text);
        values.Add("ShowText", ShowText.SelectedValue);
        values.Add("TextFont", getFontSettingText());
        values.Add("Format", ImageFormat.SelectedValue);
        values.Add("AddCheckSum", AddCheckSum.SelectedValue);
        values.Add("Rotate", Rotate.SelectedValue);
        values.Add("CodabarStartChar", CodabarStartChar.SelectedValue);
        values.Add("CodabarStopChar", CodabarStopChar.SelectedValue);
        values.Add("UPCENumberSystem", UPCENumber.SelectedValue);

        return values;
    }

    private string getFontSettingText()
    {
        string style = TextFontName.SelectedValue + "|";
        style += TextFontSize.SelectedValue + "|";
        foreach (ListItem item in TextFontStyle.Items)
        {
            if (item.Selected)
            {
                style += item.Value + ",";
            }
        }

        return style;
    }
}
